summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorFelix Fietkau <nbd@openwrt.org>2008-09-28 19:45:59 +0000
committerFelix Fietkau <nbd@openwrt.org>2008-09-28 19:45:59 +0000
commit2b2884293af3706589dd586d04e4eafe9b98d0fc (patch)
treef76fc9ce0de0e31c8953ae090b925b0eb458fe6a
parent72fd7feb0da34dc093c75be6357d7c42bb9fe324 (diff)
downloadmaster-31e0f0ae-2b2884293af3706589dd586d04e4eafe9b98d0fc.tar.gz
master-31e0f0ae-2b2884293af3706589dd586d04e4eafe9b98d0fc.tar.bz2
master-31e0f0ae-2b2884293af3706589dd586d04e4eafe9b98d0fc.zip
add option in sysupgrade to restore config from file or URL (patch from #4043)
SVN-Revision: 12772
-rwxr-xr-xpackage/base-files/files/sbin/sysupgrade16
1 files changed, 15 insertions, 1 deletions
diff --git a/package/base-files/files/sbin/sysupgrade b/package/base-files/files/sbin/sysupgrade
index 2230e5b0ca..1825cec58e 100755
--- a/package/base-files/files/sbin/sysupgrade
+++ b/package/base-files/files/sbin/sysupgrade
@@ -8,6 +8,7 @@ export INTERACTIVE=0
export VERBOSE=1
export SAVE_CONFIG=1
export DELAY=
+export CONF_IMAGE=
# parse options
while [ -n "$1" ]; do
@@ -17,6 +18,7 @@ while [ -n "$1" ]; do
-v) export VERBOSE="$(($VERBOSE + 1))";;
-q) export VERBOSE="$(($VERBOSE - 1))";;
-n) export SAVE_CONFIG=0;;
+ -f) export CONF_IMAGE="$2"; shift;;
-*)
echo "Invalid option: $1"
exit 1
@@ -38,6 +40,7 @@ Usage: $0 [options] <image file or URL>
Options:
-d <delay> add a delay before rebooting
+ -f <config> restore configuration from .tar.gz (file or url)
-i interactive mode
-n do not save configuration over reflash
-q less verbose
@@ -85,7 +88,18 @@ for check in $sysupgrade_image_check; do
}
done
-if ask_bool $SAVE_CONFIG "Keep config files over reflash"; then
+if [ -n "$CONF_IMAGE" ]; then
+ case "$(get_magic_word "$CONF_IMAGE")" in
+ # .gz files
+ 1f8b) ;;
+ *)
+ echo "Invalid config file. Please use only .tar.gz files"
+ exit 1
+ ;;
+ esac
+ get_image "$CONF_IMAGE" > "$CONF_TAR"
+ export SAVE_CONFIG=1
+elif ask_bool $SAVE_CONFIG "Keep config files over reflash"; then
do_save_conffiles
export SAVE_CONFIG=1
else